TanStack

Solid Example: CreateThrottler

import { createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { createThrottler } from '@tanstack/solid-pacer/throttler'

function App1() {
  // Use your state management library of choice
  const [instantCount, setInstantCount] = createSignal(0)
  const [throttledCount, setThrottledCount] = createSignal(0)

  // Lower-level createThrottler hook - requires you to manage your own state
  const setCountThrottler = createThrottler(
    setThrottledCount,
    {
      wait: 1000,
      // leading: true, // default
      // trailing: true, // default
      // enabled: () => instantCount() > 2,
    },
    // Alternative to setCountThrottler.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => state,
  )

  function increment() {
    // this pattern helps avoid common bugs with stale closures and state
    setInstantCount((c) => {
      const newInstantCount = c + 1 // common new value for both
      setCountThrottler.maybeExecute(newInstantCount) // throttled state update
      return newInstantCount // instant state update
    })
  }

  return (
    <div>
      <h1>TanStack Pacer createThrottler Example 1</h1>
      <table>
        <tbody>
          <setCountThrottler.Subscribe
            selector={(state) => ({ executionCount: state.executionCount })}
          >
            {(state) => (
              <>
                <tr>
                  <td>Execution Count:</td>
                  <td>{state().executionCount}</td>
                </tr>
                <tr>
                  <td>Instant Count:</td>
                  <td>{instantCount()}</td>
                </tr>
                <tr>
                  <td>Throttled Count:</td>
                  <td>{throttledCount()}</td>
                </tr>
              </>
            )}
          </setCountThrottler.Subscribe>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
        <button
          onClick={() => setCountThrottler.flush()}
          style={{ 'margin-left': '10px' }}
        >
          Flush
        </button>
      </div>
      <setCountThrottler.Subscribe selector={(state) => state}>
        {(state) => (
          <pre style={{ 'margin-top': '20px' }}>
            {JSON.stringify(state, null, 2)}
          </pre>
        )}
      </setCountThrottler.Subscribe>
    </div>
  )
}

function App2() {
  const [instantSearch, setInstantSearch] = createSignal('')
  const [throttledSearch, setThrottledSearch] = createSignal('')

  // Lower-level createThrottler hook - requires you to manage your own state
  const setSearchThrottler = createThrottler(
    setThrottledSearch,
    {
      wait: 1000,
      enabled: instantSearch().length > 2,
    },
    // Alternative to setSearchThrottler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  function handleSearchChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = target.value
    setInstantSearch(newValue)
    setSearchThrottler.maybeExecute(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer createThrottler Example 2</h1>
      <div>
        <input
          autofocus
          type="search"
          value={instantSearch()}
          onInput={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <setSearchThrottler.Subscribe
            selector={(state) => ({ executionCount: state.executionCount })}
          >
            {(state) => (
              <>
                <tr>
                  <td>Execution Count:</td>
                  <td>{state().executionCount}</td>
                </tr>
                <tr>
                  <td>Instant Search:</td>
                  <td>{instantSearch()}</td>
                </tr>
                <tr>
                  <td>Throttled Search:</td>
                  <td>{throttledSearch()}</td>
                </tr>
              </>
            )}
          </setSearchThrottler.Subscribe>
        </tbody>
      </table>
      <div>
        <button onClick={() => setSearchThrottler.flush()}>Flush</button>
      </div>
      <setSearchThrottler.Subscribe selector={(state) => state}>
        {(state) => (
          <pre style={{ 'margin-top': '20px' }}>
            {JSON.stringify(state, null, 2)}
          </pre>
        )}
      </setSearchThrottler.Subscribe>
    </div>
  )
}

function App3() {
  const [currentValue, setCurrentValue] = createSignal(50)
  const [throttledValue, setThrottledValue] = createSignal(50)
  const [instantExecutionCount, setInstantExecutionCount] = createSignal(0)

  // Lower-level createThrottler hook - requires you to manage your own state
  const setValueThrottler = createThrottler(
    setThrottledValue,
    {
      wait: 250,
      // leading: true, // default
      // trailing: true, // default
    },
    // Alternative to setValueThrottler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  function handleRangeChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = parseInt(target.value, 10)
    setCurrentValue(newValue)
    setInstantExecutionCount((c) => c + 1)
    setValueThrottler.maybeExecute(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer createThrottler Example 3</h1>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue()}
            onInput={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue()}</span>
        </label>
      </div>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Throttled Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={throttledValue()}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{throttledValue()}</span>
        </label>
      </div>
      <table>
        <tbody>
          <setValueThrottler.Subscribe
            selector={(state) => ({ executionCount: state.executionCount })}
          >
            {(state) => (
              <>
                <tr>
                  <td>Instant Execution Count:</td>
                  <td>{instantExecutionCount()}</td>
                </tr>
                <tr>
                  <td>Throttled Execution Count:</td>
                  <td>{state().executionCount}</td>
                </tr>
                <tr>
                  <td>Saved Executions:</td>
                  <td>
                    {instantExecutionCount() - state().executionCount} (
                    {instantExecutionCount() > 0
                      ? (
                          ((instantExecutionCount() - state().executionCount) /
                            instantExecutionCount()) *
                          100
                        ).toFixed(2)
                      : 0}
                    % Reduction in execution calls)
                  </td>
                </tr>
              </>
            )}
          </setValueThrottler.Subscribe>
        </tbody>
      </table>
      <div style={{ color: '#666', 'font-size': '0.9em' }}>
        <p>Throttled to 1 update per 250ms (trailing edge)</p>
      </div>
      <div>
        <button onClick={() => setValueThrottler.flush()}>Flush</button>
      </div>
      <setValueThrottler.Subscribe selector={(state) => state}>
        {(state) => (
          <pre style={{ 'margin-top': '20px' }}>
            {JSON.stringify(state, null, 2)}
          </pre>
        )}
      </setValueThrottler.Subscribe>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
      <hr />
      <App2 />
      <hr />
      <App3 />
    </div>
  ),
  document.getElementById('root')!,
)

TanStack

Svelte Example: CreateThrottler

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { createThrottler } from '@tanstack/svelte-pacer/throttler'

  let instantCount = $state(0)

  let throttledCount = $state(0)

  const setCountThrottler = createThrottler(
    (value: typeof throttledCount) => {
      throttledCount = value
    },
    () => ({
      key: 'counter',
      wait: 1000,
      // leading: true, // default
      // trailing: true, // default
      // enabled: () => instantCount > 2,
    }),
  )

  function increment() {
    const nextCount = ++instantCount
    setCountThrottler.maybeExecute(nextCount)
  }

  let instantExecutionCount = $state(0)

  let currentValue = $state(50)

  let throttledValue = $state(50)

  const setValueThrottler = createThrottler(
    (value: typeof throttledValue) => {
      throttledValue = value
    },
    () => ({
      key: 'range',
      wait: 250,
      // leading: true, // default
      // trailing: true, // default
    }),
  )

  function handleRangeChange(e: Event) {
    const newValue = parseInt((e.target as HTMLInputElement).value, 10)
    // instant state update
    currentValue = newValue
    instantExecutionCount = instantExecutionCount + 1
    // throttled state update
    setValueThrottler.maybeExecute(newValue)
  }

  let instantSearch = $state('')

  let throttledSearch = $state('')

  const setSearchThrottler = createThrottler(
    (value: typeof throttledSearch) => {
      throttledSearch = value
    },
    () => ({
      key: 'search',
      wait: 1000,
      enabled: () => instantSearch.length > 2,
    }),
  )

  function handleSearchChange(e: Event) {
    const newValue = (e.target as HTMLInputElement).value
    instantSearch = newValue
    setSearchThrottler.maybeExecute(newValue)
  }
</script>

<div>
  <div>
    <h1>TanStack Pacer createThrottler Example 1</h1>
    <table>
      <tbody
        ><setCountThrottler.Subscribe
          selector={(state) => ({ executionCount: state.executionCount })}
          >{#snippet children({ executionCount })}<tr
              ><td>Execution Count:</td><td>{executionCount}</td></tr
            ><tr><td>Instant Count:</td><td>{instantCount}</td></tr><tr
              ><td>Throttled Count:</td><td>{throttledCount}</td></tr
            >{/snippet}</setCountThrottler.Subscribe
        ></tbody
      >
    </table>
    <div>
      <button onclick={increment}>Increment</button><button
        onclick={() => setCountThrottler.flush()}
        style="margin-left: 10px"
      >
        Flush
      </button>
    </div>
    <setCountThrottler.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</setCountThrottler.Subscribe
    >
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer createThrottler Example 2</h1>
    <div>
      <!-- svelte-ignore a11y_autofocus: Focus the search field in this standalone demo. -->
      <input
        autofocus
        type="search"
        value={instantSearch}
        oninput={handleSearchChange}
        placeholder="Type to search..."
        style="width: 100%"
      />
    </div>
    <table>
      <tbody
        ><setSearchThrottler.Subscribe
          selector={(state) => ({ executionCount: state.executionCount })}
          >{#snippet children({ executionCount })}<tr
              ><td>Execution Count:</td><td>{executionCount}</td></tr
            ><tr><td>Instant Search:</td><td>{instantSearch}</td></tr><tr
              ><td>Throttled Search:</td><td>{throttledSearch}</td></tr
            >{/snippet}</setSearchThrottler.Subscribe
        ></tbody
      >
    </table>
    <div><button onclick={() => setSearchThrottler.flush()}>Flush</button></div>
    <setSearchThrottler.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</setSearchThrottler.Subscribe
    >
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer createThrottler Example 3</h1>
    <div style="margin-bottom: 20px">
      <label
        >Current Range:<input
          type="range"
          min="0"
          max="100"
          value={currentValue}
          oninput={handleRangeChange}
          style="width: 100%"
        /><span>{currentValue}</span></label
      >
    </div>
    <div style="margin-bottom: 20px">
      <label
        >Throttled Range (Readonly):<input
          type="range"
          min="0"
          max="100"
          value={throttledValue}
          disabled
          style="width: 100%"
        /><span>{throttledValue}</span></label
      >
    </div>
    <table>
      <tbody
        ><setValueThrottler.Subscribe
          selector={(state) => ({ executionCount: state.executionCount })}
          >{#snippet children({ executionCount })}<tr
              ><td>Instant Execution Count:</td><td>{instantExecutionCount}</td
              ></tr
            ><tr
              ><td>Throttled Execution Count:</td><td>{executionCount}</td></tr
            ><tr
              ><td>Saved Executions:</td><td
                >{instantExecutionCount - executionCount} ({instantExecutionCount >
                0
                  ? (
                      ((instantExecutionCount - executionCount) /
                        instantExecutionCount) *
                      100
                    ).toFixed(2)
                  : 0}% Reduction in execution calls)
              </td></tr
            >{/snippet}</setValueThrottler.Subscribe
        ></tbody
      >
    </table>
    <div style="color: #666; font-size: 0.9em">
      <p>Throttled to 1 update per 250ms (trailing edge)</p>
    </div>
    <div><button onclick={() => setValueThrottler.flush()}>Flush</button></div>
    <setValueThrottler.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</setValueThrottler.Subscribe
    >
  </div>
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}